#!/bin/bash
#
# stopproc.sh
#
echo "`date` stopproc: taking down processes" >> /var/log/logrtc.log

# when doing dtn, more to do, for loradtn, nothing specific for now
DTNNODE="no"

if [ "$DTNNODE" != "no" ]
then
	#
	/etc/init.d/monit stop
	/etc/init.d/dtnN4Cmiddle stop
	/etc/init.d/dtnN4Crecv stop
	/etc/init.d/pushrecv stop
	/etc/init.d/addaccount stop
	/etc/init.d/dtn stop
	/etc/init.d/apache2 stop
	/etc/init.d/cron stop
	/etc/init.d/dhcp3-server stop
	/etc/init.d/mysql stop

	echo "`date` stopproc: unmounting /data" >> /var/log/logrtc.log
	/bin/umount /data

	# check if the umount worked
	checkdata=`mount | grep data`
	if [ "$checkdata" != "" ]
	then
		echo "`date` Someone still messing with /data" >>/var/log/logrtc.log
		# crap something up, ask anyone with an open handle to kill
		# themselves
		pids=`lsof | grep /data | awk '{print $2}' | sort | uniq`
		for pid in $pids
		do
			echo "`date` asking $pid to close" >>/var/log/logrtc.log
			line=`ps -fp $pid | tail -1`
			echo "`date` $pid is $line" >>/var/log/logrtc.log
			kill -5 $pid
		done
		# give them a chance for last rites
		sleep 5
		echo "`date` stopproc: unmounting /data (2nd time)" >> /var/log/logrtc.log
		/bin/umount /data

	fi

	checkdata=`mount | grep data`
	if [ "$checkdata" != "" ]
	then
		# crap something still up, kill 'em dead
		echo "`date` Someone still stubbornly messing with /data" >>/var/log/logrtc.log
		pids=`lsof | grep /data | awk '{print $2}' | sort | uniq`
		for pid in $pids
		do
			echo "`date` forcing $pid to die" >>/var/log/logrtc.log
			line=`ps -fp $pid | tail -1`
			echo "`date` $pid is $line" >>/var/log/logrtc.log
			kill -9 $pid
		done
		# give them a chance for last rites
		sleep 5
		echo "`date` stopproc: unmounting /data (3nd time)" >> /var/log/logrtc.log
		/bin/umount /data
	fi

	checkdata=`mount | grep data`
	if [ "$checkdata" != "" ]
	then
		# really crap. Just reboot
		echo "`date` Still can't umount /data - rebooting" >>/var/log/logrtc.log
		/sbin/reboot
	fi
fi

service pbm stop >>/var/log/logrtc.log 2>&1
/usr/sbin/ker-off >>/var/log/logrtc.log 2>&1

echo "`date` Finished stopproc.sh" >>/var/log/logrtc.log

